# norootforbuild

Summary:	Journaline data decoder for DAB and DRM
Name:		libjournaline
Version:	20040318
Release:	0.pm.0
License:	Other (see Description)
URL:		http://www.iis.fraunhofer.de/dab/projects/journaline/
Group:		Development/Libraries/C and C++         
Source:		WinFhGJourLib.zip
Patch0:		journaline-lib.patch
Patch1:		libjournaline-0.20040318-pic.patch
BuildRoot:    	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: 	zlib-devel
BuildRequires:  gcc-c++
Requires:	zlib

%description
NewsService Journaline is a textual data application optimized for digital 
broadcast systems like DRM (Digital Radio Mondiale) and DAB (Digital Audio
Broadcasting).

This library helps decoding Journaline.

Note that this library is free only for non-commercial use.
To use the 'NewsService Journaline(R) Decoder' software for
COMMERCIAL purposes, please contact Fraunhofer IIS for a
commercial license (see below for contact information)!

Contact:
    Fraunhofer IIS, Department 'Broadcast Applications'
    Am Wolfsmantel 33, 91058 Erlangen, Germany
    http://www.iis.fraunhofer.de/dab
    mailto:bc-info@iis.fraunhofer.de
 

%package devel
Summary:	Development files for journaline
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description devel
Development files for journaline.


%prep
%setup -n %{name}-%{version} -c -T
unzip %_sourcedir/WinFhGJourLib.zip
%patch -p0
%patch1 -p 1

%build

# build the library
cd WinFhGJourLib/journaline_%{version}
make libfhgjournaline.so
 
%install

rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_includedir}/journaline
mkdir -p %{buildroot}/%{_libdir}
mkdir -p %{buildroot}/%{_defaultdocdir}
mkdir -p %{buildroot}/%{_defaultdocdir}/journaline

for n in NML.h newssvcdec.h dabdatagroupdecoder.h; do
    install -m 644 WinFhGJourLib/journaline_%{version}/$n \
        %{buildroot}/%{_includedir}/journaline
done

# install, preserving links
chmod 755 WinFhGJourLib/journaline_%{version}/libfhgjournaline.so.0
for n in WinFhGJourLib/journaline_%{version}/libfhgjournaline.so* ; do
    cp -d $n %{buildroot}/%{_libdir}
done

for n in Journaline_Overview_1.3_%{version}.pdf LICENSE README; do
    install -m 644 WinFhGJourLib/journaline_%{version}/$n \
        %{buildroot}/%{_defaultdocdir}/journaline
done

install -d %{buildroot}/%{_defaultdocdir}/journaline/html
for n in *{html,js,png,css} formula.repository; do
    install -m 644 WinFhGJourLib/journaline_%{version}/html/$n \
    %{buildroot}/%{_defaultdocdir}/journaline/html
done

# the %%post and %%postun directives are superfluous on SuSE, but harmless
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc %{_defaultdocdir}/*
%{_libdir}/libfhgjournaline.so.0

%files devel
%defattr(-, root, root)
%{_libdir}/libfhgjournaline.so
%{_includedir}/journaline/*

%changelog
* Sun Sep 02 2007 - Bernhard Walle <bernhard@links2linux.de>
- adapt for SUSE and Packman
* Thu Apr 13 2006 Wojciech Kazubski <wk at ire.pw.edu.pl> - 0.20040318-4.fc5.wk
- specfile cleanups
- rebuilt for Fedora Core 5
* Fri Jan 20 2006 Wojciech Kazubski <wk at ire.pw.edu.pl> - 0.20040318-3.fc4.wk
- devel package splited,
- 64bit patch added
* Wed Jan 11 2006 Wojciech Kazubski <wk at ire.pw.edu.pl> - 0.20040318-2.fc4.wk
- updated & cleaned specfile
* Sat Apr 17 2004 Alexander Kurpiers <a.kurpiers@nt.tu-darmstadt.de>
- first attempt

# EOF
